<script lang="ts" setup>
import {CirclePlus} from '@element-plus/icons-vue'
import { useRoomStore } from "@/stores/room";
import { storeToRefs } from "pinia";
import { onMounted, ref } from "vue";
import RoomForm from "../components/RoomForm.vue";
import ModalBooking from "../components/ModalBooking.vue";
import type { Room } from "@/entities";
import { doAndNotify } from "@/form-helpers";
const store = useRoomStore();
const { rooms } = storeToRefs(store);

const selected = ref<Room>();
const displayForm = ref(false);

onMounted(() => {
    store.fetchRooms();
});

function remove(room: Room) {
    doAndNotify(room, store.removeRoom, 'supprimer');
    selected.value = undefined;
}

function newRoom() {
    if(displayForm.value) {
        displayForm.value = false;
        return;
    }
    displayForm.value = true;
    selected.value = undefined;
}

</script>


<template>
    <h1>Gestion des salles <el-button @click="newRoom()" size="small" type="primary" :icon="CirclePlus">Nouvelle salle</el-button></h1>

    <el-card v-if="selected || displayForm">
        <h2 v-if="selected">Modifier la salle</h2>
        <h2 v-if="!selected">Nouvelle salle</h2>
        <RoomForm :room="selected" @cancel="selected = undefined, displayForm = false" />
    </el-card>
    

    <h2>Liste des salles</h2>
    <el-row :gutter="20">
        <el-col :md="6" v-for="room of rooms" :key="room.id">
            <el-card shadow="hover" class="box-card">
                <el-popconfirm title="Supprimer la salle ?" confirm-button-text="Oui" cancel-button-text="Non"
                    @confirm="remove(room)">
                    <template #reference>
                        <el-link class="remove-button" type="danger" :underline="false">
                            <el-icon>
                                <DeleteFilled />
                            </el-icon>
                        </el-link>
                    </template>
                </el-popconfirm>
                <template #header>
                    <div class="card-header">
                        <div style="width:100%">
                            <el-row align="middle" justify="space-around">
                                <span>{{room.name}}</span>
                            </el-row>
                            <el-row align="middle" justify="space-between">
                                <div>
                                    <el-tag type="info">{{ room.capacity }}</el-tag>
                                </div>
                                <div>
                                    <el-tag type="info" :color="room.color"></el-tag>
                                </div>
                            </el-row>
                        </div>
                    </div>
                </template>
                <el-row justify="space-around">
                    <ModalBooking :with-button="true" :booking="{room, startDate:new Date(), endDate: new Date()}" />

                    <el-button @click="selected = room">Modifier</el-button>
                </el-row>
            </el-card>
        </el-col>
    </el-row>

</template>

<style scoped>
.el-card {
    position: relative;
    margin-bottom: 5px;
}

.remove-button {
    position: absolute;
    top: 5px;
    right: 5px;
}

</style>